﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WT_PreventNodeFromExpanding
{
    public partial class Form1 : Form
    {
        private ContextMenu menu;
        private MenuItem copyItem;
        private MenuItem pasteItem;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataSet ds =new DataSet();

            setUpMenu();
            ds = setUpData(ds);
            ds = getData(ds);

            ultraTree1.DataSource = ds;
            ultraTree1.DataMember = "table1";

            ultraTree1.ViewStyle = Infragistics.Win.UltraWinTree.ViewStyle.Grid;
            
    
        }

        private DataSet getData(DataSet ds)
        {
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Appliances", 5, 90, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "FastFood", 20, 32, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Furniture", 12, 79, new DateTime(2009, 02, 28) });

            ds.Tables["table2"].Rows.Add(new Object[] { null, 0, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new Object[] { null, 1, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new Object[] { null, 2, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new Object[] { null, 3, "Coca - Cola", " Somewhere", 2 });

            return ds;
        }

        private DataSet setUpData(DataSet ds)
        {
            DataTable t1 = ds.Tables.Add("table1");

            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));

            DataTable t2 = ds.Tables.Add("table2");
            t2.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t2.Columns.Add("pid", typeof(int));
            t2.Columns.Add("Name", typeof(string));
            t2.Columns.Add("Address", typeof(string));
            t2.Columns.Add("Number", typeof(int));

            ds.Relations.Add(t1.Columns["id"], t2.Columns["pid"]);

            return ds;
        }

        private void setUpMenu()
        {
            menu = new ContextMenu();
            copyItem = new MenuItem("Copy");
            pasteItem = new MenuItem("Paste");
            menu.MenuItems.Add(copyItem);
            menu.MenuItems.Add(pasteItem);
            pasteItem.Enabled = false;
        }

        private void ultraTree1_MouseDown(object sender, MouseEventArgs e)
        {
            
        }

        private void ultraTree1_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                menu.Show(ultraTree1, e.Location);
            }
        }
    }
}
